#Sketchup.require 'ams_WindowSettings/sketchup window.rb'

# Scenes bar nested namespace.
# Scenes bar is SketchUp's child window with scene tabs.
# It is positioned underneath the top toolbar container.
module AMS::Sketchup::ScenesBar

  class << self  #  <--<< THIS module's anonymous singleton proxy class.

    # Retrieves hWnd to scenes bar
    def hwnd
      AMS::Sketchup.scenes_bar
    end

    alias handle hwnd


    # This function is used to show/hide the window.
    def show(state = true, refresh = true)
      state = [true,1].include?(state)
      return false if (state and disabled?)
      refresh = [true,1].include?(refresh)
      nCmdShow = (state ? 5 : 0)
      return false if (state == visible?)
      AMS::ShowWindow.call(hwnd, nCmdShow)
      AMS::Sketchup::MainWindow.refresh if refresh
      AMS::Sketchup::SettingsObserver.onShowScenesBar(state)
      true
    end


    # This function is used to determine whether the window is visible.
    def visible?
      (AMS::IsWindowVisible.call(hwnd) != 0)
    end


    # This function is used to determine whether it is valid to show the scenes bar.
    # It is valid to show the scenes bar when the window has 1+ scene tabs/pages.
    def enabled?
      (Sketchup.active_model.pages.size != 0)
    end


    # Opposite of <tt>enabled?</tt>
    def disabled?
      (Sketchup.active_model.pages.size == 0)
    end

  end # proxy class

end # module AMS::Sketchup::ScenesBar
