#Sketchup.require 'ams_WindowSettings/sketchup window.rb'

# Status bar nested namespace.
# Status bar is SketchUp child window with status text and VCB (value control box).
# It is usually located at the bottom of the SketchUp window.
module AMS::Sketchup::StatusBar

  class << self  #  <--<< THIS module's anonymous singleton proxy class.

    # Retrieves hWnd to status bar
    def hwnd
      AMS::Sketchup.status_bar
    end

    alias handle hwnd


    # This function is used to show/hide the window.
    def show(state = true, refresh = true)
      state = [true,1].include?(state)
      refresh = [true,1].include?(refresh)
      nCmdShow = (state ? 5 : 0)
      return false if (state == visible?)
      AMS::ShowWindow.call(hwnd, nCmdShow)
      AMS::Sketchup::MainWindow.refresh if refresh
      AMS::Sketchup::SettingsObserver.onShowStatusBar(state)
      true
    end


    # This function is used to determine whether the window is visible.
    def visible?
      (AMS::IsWindowVisible.call(hwnd) != 0)
    end

  end # proxy class

end # module AMS::Sketchup::StatusBar
